<template>
  <!-- 筛选条件 -->
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="设备名" prop="equipmentName">
        <el-input v-model="queryParams.equipmentName" placeholder="请输入设备名" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="标识码" prop="code">
        <el-input v-model="queryParams.code" placeholder="请输入标识码" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="设备种类" prop="equipmentType">
        <el-select v-model="queryParams.equipmentType" placeholder="请选择设备种类" clearable style="width: 150px;">
          <el-option v-for="dict in equipment_type" :key="dict.value" :label="dict.label" :value="dict.value" />
        </el-select>
      </el-form-item>
      <el-form-item label="PLC选择" prop="plcId">
        <el-select v-model="queryParams.plcId" placeholder="请选择PLC" clearable style="width: 150px;">
          <el-option v-for="dict in plcOptions" :key="dict.plcId" :label="dict.plcName" :value="dict.plcId" />
        </el-select>
      </el-form-item>
      <el-form-item label="通讯协议" prop="protocolId">
        <el-select v-model="queryParams.protocolId" placeholder="请选择通讯协议" clearable style="width: 150px;">
          <el-option v-for="dict in commProtocolOptions" :key="dict.protocolId" :label="dict.protocolName"
            :value="dict.protocolId" />
        </el-select>
      </el-form-item>
      <el-form-item label="流程选择" prop="flowIds">
        <el-select v-model="queryParams.flowIds" placeholder="请选择对应流程" clearable style="width: 150px;">
          <el-option v-for="dict in flowOptions" :key="dict.flowId" :label="dict.flowName" :value="dict.flowId" />
        </el-select>
      </el-form-item>
      <el-form-item label="状态" prop="status">
        <el-select v-model="queryParams.status" placeholder="状态" clearable style="width: 150px">
          <el-option v-for="dict in sys_normal_disable" :key="dict.value" :label="dict.label" :value="dict.value" />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="Plus" @click="handleAdd"
          v-hasPermi="['hnyz:equipment:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate"
          v-hasPermi="['hnyz:equipment:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete"
          v-hasPermi="['hnyz:equipment:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="Download" @click="handleExport"
          v-hasPermi="['hnyz:equipment:export']">导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>
    <!-- 表单列表 -->
    <el-table v-loading="loading" :data="equipmentList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <!-- <el-table-column label="设备id" align="center" prop="equipmentId" /> -->
      <el-table-column label="设备名" align="center" prop="equipmentName" />
      <el-table-column label="流程归属" align="center" prop="flowName" :show-overflow-tooltip="true" />
      <el-table-column label="标识码" align="center" prop="code" />
      <el-table-column label="设备种类" align="center" prop="equipmentType">
        <template #default="scope">
          <dict-tag :options="equipment_type" :value="scope.row.equipmentType" />
        </template>
      </el-table-column>
      <!-- <el-table-column label="plc名称" align="center" prop="plcName" />
      <el-table-column label="通讯协议" align="center" prop="protocolName" /> -->
      <el-table-column label="启用状态" align="center" width="100">
        <template #default="scope">
          <el-switch v-model="scope.row.status" active-value="0" inactive-value="1"
            @change="handleStatusChange(scope.row)"></el-switch>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)"
            v-hasPermi="['hnyz:equipment:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)"
            v-hasPermi="['hnyz:equipment:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize" @pagination="getList" />

    <!-- 添加或修改设备管理对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="equipmentRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="设备名" prop="equipmentName">
          <el-input v-model="form.equipmentName" placeholder="请输入设备名" />
        </el-form-item>
        <el-form-item label="标识码" prop="code">
          <el-input v-model="form.code" placeholder="请输入标识码" />
        </el-form-item>
        <el-form-item label="设备种类" prop="equipmentType">
          <el-select v-model="form.equipmentType" placeholder="请选择设备种类">
            <el-option v-for="dict in equipment_type" :key="dict.value" :label="dict.label"
              :value="dict.value"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="流程分配" prop="flowIds">
          <el-select v-model="form.flowIds" multiple placeholder="请选择对应流程" clearable @clear="clearFlow">
            <el-option v-for="dict in flowOptions" :key="dict.flowId" :label="dict.flowName"
              :value="dict.flowId"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="PLC" prop="plcId">
          <el-select v-model="form.plcId" placeholder="请选择plc" clearable @clear="clearPLC">
            <el-option v-for="dict in plcOptions" :key="dict.plcId" :label="dict.plcName"
              :value="dict.plcId"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="通讯协议" prop="protocolId">
          <el-select v-model="form.protocolId" placeholder="请选择通讯协议" :disabled="form.plcId != null">
            <el-option v-for="dict in commProtocolOptions" :key="dict.protocolId" :label="dict.protocolName"
              :value="dict.protocolId"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="通信地址" prop="ipAddress">
          <el-input v-model="form.ipAddress" placeholder="请输入通信地址"  :disabled="form.plcId != null"/>
        </el-form-item>
        <el-form-item label="通信端口" prop="port">
          <el-input v-model="form.port" placeholder="请输入通信端口"  :disabled="form.plcId != null"/>
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入备注" />
        </el-form-item>
        <el-form-item label="启用状态">
          <el-radio-group v-model="form.status">
            <el-radio v-for="dict in sys_normal_disable" :key="dict.value" :value="dict.value">{{ dict.label
            }}</el-radio>
          </el-radio-group>
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Equipment">
import { changeStatus, listEquipment, getEquipment, delEquipment, addEquipment, updateEquipment } from "@/api/hnyz/equipment";
import { getFlowList, listFlow } from "@/api/hnyz/flow";
import { getPlcList } from "@/api/hnyz/plcInfo";
import { getCommProtocolList } from "@/api/hnyz/commProtocol";
import { onMounted } from "vue";

onMounted(() => {
  getOptions();
});

// 获取所有下拉树结构
function getOptions() {
  getFlowOptions();
  getPlcOptions();
  getCommProtocolOptions();
}

const flowOptions = ref([]);// 流程下拉树结构
/** 获取流程列表 */
function getFlowOptions() {
  const params = {
    // flowType: '1',// 1: 普通流程
  };
  getFlowList(params).then(response => {
    flowOptions.value = response.data;
    // console.log(flowOptions.value);
  });
  // listFlow().then(response => {
  //   flowOptions.value = response.rows;
  //   // console.log(flowOptions.value);
  // });
}
function clearFlow() {
  form.value.flowIds = [];
}

const plcOptions = ref([]);// plc下拉树结构
/** 获取plc列表 */
function getPlcOptions() {
  getPlcList().then(response => {
    plcOptions.value = response.data;
  });
}
function clearPLC() {
  form.value.plcId = null;
}

const commProtocolOptions = ref([]);// 通讯协议下拉树结构
/** 获取通讯协议列表 */
function getCommProtocolOptions() {
  getCommProtocolList().then(response => {
    commProtocolOptions.value = response.data;
  });
}
const { proxy } = getCurrentInstance();
const { equipment_type } = proxy.useDict('equipment_type');
const { sys_normal_disable } = proxy.useDict("sys_normal_disable");
const equipmentList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    equipmentName: null,
    flowIds: null,
    code: null,
    equipmentType: null,
    plcId: null,
    protocolId: null,
    status: null,
    remark: null
  },
  rules: {
    equipmentName: [
      { required: true, message: "请输入设备名", trigger: "blur" },
      { min: 1, max: 50, message: "长度在 1 到 50 个字符", trigger: "blur" }
    ],
    flowIds: [
      { required: true, message: "请选择对应流程", trigger: "blur" }
    ],
    code: [
      { required: true, message: "请输入标识码", trigger: "blur" },
    ],
    equipmentType: [
      { required: true, message: "请选择设备类型", trigger: "blur" }
    ],
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询设备管理列表 */
function getList() {
  loading.value = true;
  listEquipment(queryParams.value).then(response => {
    equipmentList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

// 表单重置
function reset() {
  form.value = {
    equipmentId: null,
    equipmentName: null,
    flowIds: null,
    code: null,
    equipmentType: null,
    plcId: null,
    plcName: null,
    protocolName: null,
    flowName: null,
    protocolId: null,
    status: "0",
    remark: null
  };
  proxy.resetForm("equipmentRef");
}

/** 状态修改 */
function handleStatusChange(row) {
  let text = row.status == "0" ? "启用" : "停用";
  proxy.$modal.confirm('确认要"' + text + '"设备名为"' + row.equipmentName + '"的数据项吗?').then(function () {
    return changeStatus(row.equipmentId, row.status);
  }).then(() => {
    proxy.$modal.msgSuccess(text + "成功");
  }).catch(function () {
    row.status = row.status == "0" ? "1" : "0";
  });
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.equipmentId);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加设备管理";
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const _equipmentId = row.equipmentId || ids.value
  getEquipment(_equipmentId).then(response => {
    form.value = response.data;
    //字符串转整型数组
    if (form.value.flowIds) {
      form.value.flowIds = form.value.flowIds.split(',').map(Number);
    }
    open.value = true;
    title.value = "修改设备管理";
  });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["equipmentRef"].validate(valid => {
    if (valid) {
      if (form.value.flowIds) {
        //数组转字符串
        form.value.flowIds = form.value.flowIds.join(',');
      }
      if (form.value.equipmentId != null) {
        console.log('form.value', form.value);
        
        updateEquipment(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        }).catch(error => {
          form.value.flowIds = form.value.flowIds.split(',').map(Number);
        });
      } else {
        addEquipment(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        }).catch(error => {
          console.log(error);
          form.value.flowIds = form.value.flowIds.split(',').map(Number);
        });
      }
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _equipmentIds = row.equipmentId || ids.value;
  proxy.$modal.confirm('是否确认删除设备管理编号为"' + _equipmentIds + '"的数据项？').then(function () {
    return delEquipment(_equipmentIds);
  }).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  }).catch(() => { });
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('hnyz/equipment/export', {
    ...queryParams.value
  }, `equipment_${new Date().getTime()}.xlsx`)
}

getList();
</script>
